import axios from 'axios';
import Vue from 'vue'
import router from '@/router.js';
axios.defaults.timeout = 10000; //设置超时时长
axios.defaults.baseURL ='';

//http request 拦截器
axios.interceptors.request.use(
  config => {
    // const token = getCookie('名称');
        config.data = JSON.stringify(config.data);
        console.log(config,'config设置')
    if (config.url.indexOf('coreapiscn') != -1) {//台湾接口
      if (localStorage.getItem('TWtoken')) {
        config.headers = {
          'Content-Type': 'application/json',
          'Authorization': localStorage.getItem('TWtoken'),
        }
      } else if (localStorage.getItem('mobiletoken')){
        config.headers = {
          'Content-Type': 'application/json',
            'Authorization': localStorage.getItem('mobiletoken')
        }
      }
    } else {//醍摩豆接口
        //if (localStorage.getItem('usertoken')) {
        //    console.log('进入到有头部内容')
        //    config.headers = {
        //        'Content-Type': 'application/json',
        //        'Authorization': 'Bearer ' + localStorage.getItem('usertoken')
        //    }
        //    console.log(config.headers,'进入到有头部后内容')
        //}
      if (localStorage.getItem('TMDtoken')) {
        if(config.url.indexOf('UploadDocument') != -1){//上传接口
          config.headers = {
            'Content-Type': 'multipart/form-data',
            'Authorization':'Bearer '+ localStorage.getItem('TMDtoken'),
            'lang': localStorage.getItem('local')
          }
          }else{
          config.headers = {
            'Content-Type': 'application/json',
            'Authorization': 'Bearer '+localStorage.getItem('TMDtoken'),
            'lang': localStorage.getItem('local')
          }
        }
      }else {
        config.headers = {
          'Content-Type': 'application/json',
          'Authorization': 'Bearer ' + localStorage.getItem('usertoken')
        }
      }
    }
    return config;
  },
  error => {
    return Promise.reject(err);
  }
);


//http response 拦截器
// axios.interceptors.response.use(
//   response => {
//     if (response.data.errCode == 2) {
//       router.push({
//         path: "/login",
//         querry: { redirect: router.currentRoute.fullPath }//从哪个页面跳转
//       })
//     }
//     return response;
//   },
//   error => {
//     if (401 === error.response.status) {
//       // localStorage.clear();
//       window.location.href = window.location.origin;
//       //alert("登录状态已过期！请重新登录！");
//     } else if (500 === error.response.status) {
//       //alert("服务器错误！");
//     } else {
//       return Promise.reject(error);
//     }
//   }
// )


/**
 * 封装get方法
 * @param url
 * @param data
 * @returns {Promise}
 */

export function fetch(url, params) {
  let data = {};
  data.method = url;
  data.params = params;
  data.lang = localStorage.getItem('local');
  return new Promise((resolve,reject) => {
    axios.get(url, data)
      .then(response => {
        resolve(response.data);
      //  this.$Message.success('数据访问成功！');
      })
      .catch(err => {
        reject(err);
        this.$Message.error('数据访问错误！');
      })
  })
}

/**
 * 封装post请求
 * @param url
 * @param data
 * @returns {Promise}
 */

export function post(url, params) {
  let data = {};
  data.method = url;
  data.params = params;
  data.lang = localStorage.getItem('local');
  return new Promise((resolve,reject) => {
    axios.post(url,params)
      .then(response => {
        resolve(response.data);
       // this.$Message.success('数据访问成功！');
      },err => {
        reject(err);
        //this.$Message.error('数据访问错误！');
      })
  })
}
