using SqlSugar;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace HiTeachCE.Models
{
    [SugarTable("ActivationCode")]
    public class ActivationCode : Model
    {
        [SugarColumn(IsNullable = false, IsPrimaryKey = true)]
        public string id { get; set; }
        /// <summary>
        /// cdkey产品激活码
        /// </summary>
        [SugarColumn(IsNullable = false)]
        public string cdkey { get; set; }
        /// <summary>
        /// 最大人数
        /// </summary>
        [Required(ErrorMessage = "授权上限必须填写")]
        [Range(1, 1000, ErrorMessage = "请输入1~1000的整数")]
        public int maximum { get; set; }
        /// <summary>
        /// 绑定机构
        /// </summary>
        [SugarColumn(IsNullable = false)]
        [Required(ErrorMessage = "组织机构必须设置")]
        public string orgCode { get; set;}
        /// <summary>
        /// 到期日期秒数
        /// </summary>   
        [Required(ErrorMessage = "授权时限必须填写")]
        [Range(-1, long.MaxValue, ErrorMessage = "请输入大于等于-1的整数")]
        public long expires { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        public long createTime { get; set; }
        /// <summary>
        /// 产品8码 可以重新生成
        /// </summary>
        [SugarColumn(IsNullable = false)]
        public string clientId { get; set; }
        /// <summary>
        /// 产品密钥
        /// </summary>
        [SugarColumn(IsNullable = false)]
        public string secret { get; set; }
        public int status { get; set; }

    }
}
