using SqlSugar;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace HiTeachCE.Models
{
    [SugarTable("Member")]
    public class Member : Model
    {
        [SugarColumn(IsNullable = false, IsPrimaryKey = true)]
        public string id { get ; set ; }
        [Required(ErrorMessage = "成员unionid必须设置")]
        public string unionid { get; set; }
        public string memberName { get; set; }
        [Required(ErrorMessage = "组织机构必须设置")]
        public string orgCode { get; set; }
        /// <summary>
        ///  1 是管理员， 0 普通成员
        /// </summary>
        [Required(ErrorMessage = "是否组织管理员必须设置")]
        [Range(0,1, ErrorMessage = "组织管理员请设置0~1的整数")]
        public int admin { get; set; }
        ///// <summary>
        ///// 到期日期时间戳 ，-1永不过期
        ///// </summary>
        //[Required(ErrorMessage = "授权时长必须填写")]
        //[Range(-1, 15552000, ErrorMessage = "授权时长请设置-1~180的整数")]
        //public long expires { get; set; }
        /// <summary>
        /// 0 1 
        /// </summary>
        [Required(ErrorMessage = "状态必须设置")]
        [Range(0,1, ErrorMessage = "状态请设置 0-1的整数")]
        public int status { get; set; }
        public long createTime { get; set; }
    }
}
