using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Security.Cryptography.X509Certificates;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Server.Kestrel.Core;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Hosting;
using Microsoft.Extensions.Logging;
using MQTTnet.AspNetCore;
namespace HiTeachCE
{
    public class Program
    {
        public static void Main(string[] args)
        {
            string h1 = BCrypt.Net.BCrypt.HashPassword("https://sokrates.habookaclass.biz");
            string h2 = BCrypt.Net.BCrypt.HashPassword(h1);
            bool validPassword = BCrypt.Net.BCrypt.Verify(h1, h2);
            CreateHostBuilder(args).Build().Run();
        }

        public static IHostBuilder CreateHostBuilder(string[] args) =>
            Host.CreateDefaultBuilder(args)
                .ConfigureWebHostDefaults(webBuilder =>
                {
                    webBuilder.UseKestrel(o => {
                        //o.ListenAnyIP(1884, l => l.UseMqtt());
                        o.ListenAnyIP(3001, l => { l.UseMqtt();  });
                        o.ListenAnyIP(4000); // default http pipeline
                        o.ListenAnyIP(4001, listenOptions =>
                        {
                            listenOptions.UseHttps("habook.pfx", "habook");
                            // listenOptions.UseHttps("cert.pfx", "Pa$$w0rd");
                        });
                    }).UseStartup<Startup>();
                });
    }
}
